#include "woody.h"

int gen_key_xor(void **key) {
	int fd = open("/dev/urandom", O_RDONLY);
	if (fd == -1) {
		return wdy_perror("/dev/urandom");
	}
	*key = malloc(sizeof(uint64_t));
	if (!key) {
		return wdy_perror("malloc");
	}
	if (read(fd, *key, sizeof(uint64_t)) != 8) {
		return wdy_perror("/dev/urandom");
	}
	close(fd);
	return RET_OK;
}

void print_key(uint64_t key) {
	uint64_t mask = 0xf000000000000000;
	ft_printf("info: private_key: 0x");
	for (int i = 60; i >= 0; i -= 4) {
		uint64_t print = (key & mask) >> i;
		if (print < 10) {
			print += '0';
			write(1, &print, 1);
		}
		else {
			print += 'a' - 10;
			write(1, &print, 1);
		}
		mask >>= 4;
	}
	write (1, "\n", 1);
}

int encrypt_xor(t_map file, void *key_ptr, Elf64_Phdr load_segment) {
	// TODO try oneliner
	uint64_t *tmp = key_ptr;
	uint64_t key = *tmp;

	print_key(key);
	size_t i = 0;
	while (i < load_segment.p_filesz >> 3) {
		((uint64_t *)file.data)[i + (load_segment.p_offset >> 3)] ^= key;
		i++;
	}
	key <<= (8 - (load_segment.p_filesz % 8)) * 8;
	key >>= (8 - (load_segment.p_filesz % 8)) * 8;
	((uint64_t *)file.data)[i + (load_segment.p_offset >> 3)] ^= key;
	return RET_OK;
}

t_payload64 get_xor_payload64(void) {
	t_payload64 payload;

	payload.algo_name = ft_strdup("xor");
	payload.len = 155;
	payload.jump_offset = 113;
	payload.load_ptr_offset = 131;
	payload.load_size_offset = 139;
	payload.private_key_offset = 147;
	payload.encrypt = &encrypt_xor;
	payload.gen_key = &gen_key_xor;
	payload.data = malloc(payload.len * sizeof(unsigned char));
	ft_memcpy(payload.data,
			"\x50\x51\x52\x56\x57\x48\x8d\x3d\xf4\xff\xff\xff\x48\x2b\x3d\x70"
			"\x00\x00\x00\x48\x8b\x35\x71\x00\x00\x00\x48\x8b\x15\x72\x00\x00"
			"\x00\x48\x89\xf1\x48\xf7\xd1\x48\x83\xe1\x07\x48\xff\xc1\x48\xc1"
			"\xe1\x03\x48\x89\xd0\x48\xd3\xe0\x48\xd3\xe8\x48\x83\xe6\xf8\x48"
			"\x31\x04\x37\x48\x83\xee\x08\x48\x83\xfe\xf8\x74\x06\x48\x31\x14"
			"\x37\xeb\xf0\x48\x8d\x35\x1b\x00\x00\x00\xbf\x01\x00\x00\x00\xba"
			"\x0e\x00\x00\x00\xb8\x01\x00\x00\x00\x0f\x05\x5f\x5e\x5a\x59\x58"
			"\xe9\x65\xda\xda\xda\x2e\x2e\x2e\x2e\x57\x4f\x4f\x44\x59\x2e\x2e"
			"\x2e\x2e\x0a\xba\xba\xba\xba\xba\xba\xba\xba\xca\xca\xca\xca\xca"
			"\xca\xca\xca\xcd\xab\xef\xcd\xab\xef\xcd\xab",
			payload.len);
	return payload;
}
